Commit 50cdf0b5 authored by Tuukka Pasanen's avatar Tuukka Pasanen Committed by Daniel Black

MDEV-30952: Reformat Debian pre- and postscripts if-clauses

Debian install scripts if-clauses are not formatted
as they should be. This commit formats Debian
Pre and Post script if-clauses.
parent 8febdfa3
...@@ -7,7 +7,12 @@ set -e ...@@ -7,7 +7,12 @@ set -e
# Automatically set version to ease maintenance of this file # Automatically set version to ease maintenance of this file
MAJOR_VER="${DPKG_MAINTSCRIPT_PACKAGE#mariadb-server-}" MAJOR_VER="${DPKG_MAINTSCRIPT_PACKAGE#mariadb-server-}"
if [ -n "$DEBIAN_SCRIPT_DEBUG" ]; then set -v -x; DEBIAN_SCRIPT_TRACE=1; fi if [ -n "$DEBIAN_SCRIPT_DEBUG" ]
then
set -v -x
DEBIAN_SCRIPT_TRACE=1
fi
${DEBIAN_SCRIPT_TRACE:+ echo "#42#DEBUG# RUNNING $0 $*" 1>&2 } ${DEBIAN_SCRIPT_TRACE:+ echo "#42#DEBUG# RUNNING $0 $*" 1>&2 }
export PATH=$PATH:/sbin:/usr/sbin:/bin:/usr/bin export PATH=$PATH:/sbin:/usr/sbin:/bin:/usr/bin
...@@ -25,7 +30,9 @@ case "$1" in ...@@ -25,7 +30,9 @@ case "$1" in
# and because changed configuration options should take effect immediately. # and because changed configuration options should take effect immediately.
# In case the server wasn't running at all it should be ok if the stop # In case the server wasn't running at all it should be ok if the stop
# script fails. I can't tell at this point because of the cleaned /run. # script fails. I can't tell at this point because of the cleaned /run.
set +e; invoke-rc.d mariadb stop; set -e set +e
invoke-rc.d mariadb stop
set -e
# An existing /etc/init.d/mysql might be on the system if there was a # An existing /etc/init.d/mysql might be on the system if there was a
# previous MySQL or MariaDB installation, since /etc/init.d files are # previous MySQL or MariaDB installation, since /etc/init.d files are
...@@ -65,21 +72,26 @@ case "$1" in ...@@ -65,21 +72,26 @@ case "$1" in
# If the following symlink exists, it is a preserved copy the old data dir # If the following symlink exists, it is a preserved copy the old data dir
# created by the preinst script during a upgrade that would have otherwise # created by the preinst script during a upgrade that would have otherwise
# been replaced by an empty mysql dir. This should restore it. # been replaced by an empty mysql dir. This should restore it.
for dir in DATADIR LOGDIR; do for dir in DATADIR LOGDIR
do
if [ "$dir" = "DATADIR" ]; then if [ "$dir" = "DATADIR" ]
then
targetdir=$mysql_datadir targetdir=$mysql_datadir
else else
targetdir=$mysql_logdir targetdir=$mysql_logdir
fi fi
savelink="$mysql_upgradedir/$dir.link" savelink="$mysql_upgradedir/$dir.link"
if [ -L "$savelink" ]; then if [ -L "$savelink" ]
then
# If the targetdir was a symlink before we upgraded it is supposed # If the targetdir was a symlink before we upgraded it is supposed
# to be either still be present or not existing anymore now. # to be either still be present or not existing anymore now.
if [ -L "$targetdir" ]; then if [ -L "$targetdir" ]
then
rm "$savelink" rm "$savelink"
elif [ ! -d "$targetdir" ]; then elif [ ! -d "$targetdir" ]
then
mv "$savelink" "$targetdir" mv "$savelink" "$targetdir"
else else
# this should never even happen, but just in case... # this should never even happen, but just in case...
...@@ -116,16 +128,26 @@ EOF ...@@ -116,16 +128,26 @@ EOF
lsof -nt "$mysql_datadir"/mysql/user.MYD > /dev/null lsof -nt "$mysql_datadir"/mysql/user.MYD > /dev/null
lsof_rtn_code=$? lsof_rtn_code=$?
if [ -f "$mysql_datadir/auto.cnf" ] && [ -f "$mysql_datadir/mysql/user.MYD" ] && if [ -f "$mysql_datadir/auto.cnf" ] && [ -f "$mysql_datadir/mysql/user.MYD" ] &&
[ ! ${lsof_rtn_code} ] && [ ! -f "$mysql_datadir/undo_001" ]; then [ ! ${lsof_rtn_code} ] && [ ! -f "$mysql_datadir/undo_001" ]
then
echo "UPDATE mysql.user SET plugin='unix_socket' WHERE plugin='auth_socket';" | echo "UPDATE mysql.user SET plugin='unix_socket' WHERE plugin='auth_socket';" |
mariadbd --skip-innodb --key_buffer_size=0 --default-storage-engine=MyISAM --bootstrap 2> /dev/null mariadbd --skip-innodb --key_buffer_size=0 --default-storage-engine=MyISAM --bootstrap 2> /dev/null
fi fi
# Ensure the existence and right permissions for the database and # Ensure the existence and right permissions for the database and
# log files. Use mkdir option 'Z' to create with correct SELinux context. # log files. Use mkdir option 'Z' to create with correct SELinux context.
if [ ! -d "$mysql_statedir" ] && [ ! -L "$mysql_statedir" ]; then mkdir -Z "$mysql_statedir"; fi if [ ! -d "$mysql_statedir" ] && [ ! -L "$mysql_statedir" ]
if [ ! -d "$mysql_datadir" ] && [ ! -L "$mysql_datadir" ]; then mkdir -Z "$mysql_datadir" ; fi then
if [ ! -d "$mysql_logdir" ] && [ ! -L "$mysql_logdir" ]; then mkdir -Z "$mysql_logdir" ; fi mkdir -Z "$mysql_statedir"
fi
if [ ! -d "$mysql_datadir" ] && [ ! -L "$mysql_datadir" ]
then
mkdir -Z "$mysql_datadir"
fi
if [ ! -d "$mysql_logdir" ] && [ ! -L "$mysql_logdir" ]
then
mkdir -Z "$mysql_logdir"
fi
# When creating an ext3 jounal on an already mounted filesystem like e.g. # When creating an ext3 jounal on an already mounted filesystem like e.g.
# /var/lib/mysql, you get a .journal file that is not modifiable by chown. # /var/lib/mysql, you get a .journal file that is not modifiable by chown.
# The mysql_statedir must not be writable by the mysql user under any # The mysql_statedir must not be writable by the mysql user under any
...@@ -186,11 +208,13 @@ EOF ...@@ -186,11 +208,13 @@ EOF
# --defaults-file option for tools (for the sake of upgrades) # --defaults-file option for tools (for the sake of upgrades)
# and thus need /etc/mysql/debian.cnf to exist, even if it's empty. # and thus need /etc/mysql/debian.cnf to exist, even if it's empty.
# In the long run the goal is to obsolete this file. # In the long run the goal is to obsolete this file.
dc=$mysql_cfgdir/debian.cnf; dc="$mysql_cfgdir/debian.cnf"
if [ ! -d "$mysql_cfgdir" ]; then if [ ! -d "$mysql_cfgdir" ]
then
install -o 0 -g 0 -m 0755 -d $mysql_cfgdir install -o 0 -g 0 -m 0755 -d $mysql_cfgdir
fi fi
if [ ! -e "$dc" ]; then if [ ! -e "$dc" ]
then
cat /dev/null > $dc cat /dev/null > $dc
{ {
echo "# THIS FILE IS OBSOLETE. STOP USING IT IF POSSIBLE."; echo "# THIS FILE IS OBSOLETE. STOP USING IT IF POSSIBLE.";
...@@ -220,8 +244,10 @@ EOF ...@@ -220,8 +244,10 @@ EOF
# on by default) to work both to disable a default profile, and to keep # on by default) to work both to disable a default profile, and to keep
# any profile installed and maintained by users themselves. # any profile installed and maintained by users themselves.
profile="/etc/apparmor.d/usr.sbin.mariadbd" profile="/etc/apparmor.d/usr.sbin.mariadbd"
if [ -f "$profile" ] && aa-status --enabled 2>/dev/null; then if [ -f "$profile" ] && aa-status --enabled 2>/dev/null
if grep -q /usr/sbin/mariadbd "$profile" 2>/dev/null ; then then
if grep -q /usr/sbin/mariadbd "$profile" 2>/dev/null
then
apparmor_parser -r "$profile" || true apparmor_parser -r "$profile" || true
else else
echo "/usr/sbin/mariadbd { }" | apparmor_parser --remove 2>/dev/null || true echo "/usr/sbin/mariadbd { }" | apparmor_parser --remove 2>/dev/null || true
...@@ -233,14 +259,14 @@ EOF ...@@ -233,14 +259,14 @@ EOF
# Note that file cannot be empty, otherwise systemd version in Ubuntu Bionic # Note that file cannot be empty, otherwise systemd version in Ubuntu Bionic
# will think the service is masked # will think the service is masked
echo "# empty placeholder" > /etc/systemd/system/mariadb.service.d/migrated-from-my.cnf-settings.conf echo "# empty placeholder" > /etc/systemd/system/mariadb.service.d/migrated-from-my.cnf-settings.conf
;; ;;
abort-upgrade|abort-remove|abort-configure) abort-upgrade|abort-remove|abort-configure)
;; ;;
triggered) triggered)
if [ -d /run/systemd/system ]; then if [ -d /run/systemd/system ]
then
systemctl --system daemon-reload systemctl --system daemon-reload
else else
invoke-rc.d mariadb restart invoke-rc.d mariadb restart
...@@ -260,19 +286,23 @@ db_stop # in case invoke fails ...@@ -260,19 +286,23 @@ db_stop # in case invoke fails
# systemctl. If we upgrade from MySQL mysql.service may be masked, which also # systemctl. If we upgrade from MySQL mysql.service may be masked, which also
# means init.d script is disabled. Unmask mysql service explicitly. # means init.d script is disabled. Unmask mysql service explicitly.
# Check first that the command exists, to avoid emitting any warning messages. # Check first that the command exists, to avoid emitting any warning messages.
if [ -x "$(command -v deb-systemd-helper)" ]; then if [ -x "$(command -v deb-systemd-helper)" ]
then
deb-systemd-helper unmask mysql.service > /dev/null deb-systemd-helper unmask mysql.service > /dev/null
fi fi
#DEBHELPER# #DEBHELPER#
# Modified dh_systemd_start snippet that's not added automatically # Modified dh_systemd_start snippet that's not added automatically
if [ -d /run/systemd/system ]; then if [ -d /run/systemd/system ]
then
systemctl --system daemon-reload >/dev/null || true systemctl --system daemon-reload >/dev/null || true
deb-systemd-invoke start mariadb.service >/dev/null || true deb-systemd-invoke start mariadb.service >/dev/null || true
# Modified dh_installinit snippet to only run with sysvinit # Modified dh_installinit snippet to only run with sysvinit
elif [ -x "/etc/init.d/mariadb" ]; then elif [ -x "/etc/init.d/mariadb" ]
if [ "$1" = "configure" ] || [ "$1" = "abort-upgrade" ]; then then
if [ "$1" = "configure" ] || [ "$1" = "abort-upgrade" ]
then
invoke-rc.d mariadb start || exit $? invoke-rc.d mariadb start || exit $?
fi fi
fi fi
...@@ -7,7 +7,12 @@ set -e ...@@ -7,7 +7,12 @@ set -e
# Automatically set version to ease maintenance of this file # Automatically set version to ease maintenance of this file
MAJOR_VER="${DPKG_MAINTSCRIPT_PACKAGE#mariadb-server-}" MAJOR_VER="${DPKG_MAINTSCRIPT_PACKAGE#mariadb-server-}"
if [ -n "$DEBIAN_SCRIPT_DEBUG" ]; then set -v -x; DEBIAN_SCRIPT_TRACE=1; fi if [ -n "$DEBIAN_SCRIPT_DEBUG" ]
then
set -v -x
DEBIAN_SCRIPT_TRACE=1
fi
${DEBIAN_SCRIPT_TRACE:+ echo "#42#DEBUG# RUNNING $0 $*" 1>&2 } ${DEBIAN_SCRIPT_TRACE:+ echo "#42#DEBUG# RUNNING $0 $*" 1>&2 }
MYADMIN="/usr/bin/mysqladmin --defaults-file=/etc/mysql/debian.cnf" MYADMIN="/usr/bin/mysqladmin --defaults-file=/etc/mysql/debian.cnf"
...@@ -18,7 +23,10 @@ MYADMIN="/usr/bin/mysqladmin --defaults-file=/etc/mysql/debian.cnf" ...@@ -18,7 +23,10 @@ MYADMIN="/usr/bin/mysqladmin --defaults-file=/etc/mysql/debian.cnf"
stop_server() { stop_server() {
# Return immediately if there are no mysqld processes running # Return immediately if there are no mysqld processes running
# as there is no point in trying to shutdown in that case. # as there is no point in trying to shutdown in that case.
if ! pgrep -x --nslist pid --ns $$ "mysqld|mariadbd" > /dev/null; then return; fi if ! pgrep -x --nslist pid --ns $$ "mysqld|mariadbd" > /dev/null
then
return
fi
set +e set +e
invoke-rc.d mariadb stop invoke-rc.d mariadb stop
...@@ -27,7 +35,8 @@ stop_server() { ...@@ -27,7 +35,8 @@ stop_server() {
set -e set -e
# systemctl could emit exit code 100=no init script (fresh install) # systemctl could emit exit code 100=no init script (fresh install)
if [ "$errno" != 0 ] && [ "$errno" != 100 ]; then if [ "$errno" != 0 ] && [ "$errno" != 100 ]
then
echo "Attempt to stop MariaDB/MySQL server returned exitcode $errno" 1>&2 echo "Attempt to stop MariaDB/MySQL server returned exitcode $errno" 1>&2
echo "There is a MariaDB/MySQL server running, but we failed in our attempts to stop it." 1>&2 echo "There is a MariaDB/MySQL server running, but we failed in our attempts to stop it." 1>&2
echo "Stop it yourself and try again!" 1>&2 echo "Stop it yourself and try again!" 1>&2
...@@ -39,7 +48,8 @@ stop_server() { ...@@ -39,7 +48,8 @@ stop_server() {
case "$1" in case "$1" in
purge|remove|upgrade|failed-upgrade|abort-install|abort-upgrade|disappear) purge|remove|upgrade|failed-upgrade|abort-install|abort-upgrade|disappear)
if [ -n "$($MYADMIN ping 2>/dev/null)" ]; then if [ -n "$($MYADMIN ping 2>/dev/null)" ]
then
stop_server stop_server
sleep 2 sleep 2
fi fi
...@@ -55,7 +65,8 @@ esac ...@@ -55,7 +65,8 @@ esac
# - Remove the mysql user only after all his owned files are purged. # - Remove the mysql user only after all his owned files are purged.
# - Cleanup the initscripts only if this was the last provider of them # - Cleanup the initscripts only if this was the last provider of them
# #
if [ "$1" = "purge" ] && [ -f "/var/lib/mysql/debian-$MAJOR_VER.flag" ]; then if [ "$1" = "purge" ] && [ -f "/var/lib/mysql/debian-$MAJOR_VER.flag" ]
then
# we remove the mysql user only after all his owned files are purged # we remove the mysql user only after all his owned files are purged
rm -f /var/log/mysql.{log,err}{,.0,.[1234567].gz} rm -f /var/log/mysql.{log,err}{,.0,.[1234567].gz}
rm -rf /var/log/mysql rm -rf /var/log/mysql
...@@ -63,7 +74,8 @@ if [ "$1" = "purge" ] && [ -f "/var/lib/mysql/debian-$MAJOR_VER.flag" ]; then ...@@ -63,7 +74,8 @@ if [ "$1" = "purge" ] && [ -f "/var/lib/mysql/debian-$MAJOR_VER.flag" ]; then
db_input high "mariadb-server-$MAJOR_VER/postrm_remove_databases" || true db_input high "mariadb-server-$MAJOR_VER/postrm_remove_databases" || true
db_go || true db_go || true
db_get "mariadb-server-$MAJOR_VER/postrm_remove_databases" || true db_get "mariadb-server-$MAJOR_VER/postrm_remove_databases" || true
if [ "$RET" = "true" ]; then if [ "$RET" = "true" ]
then
# never remove the debian.cnf when the databases are still existing # never remove the debian.cnf when the databases are still existing
# else we ran into big trouble on the next install! # else we ran into big trouble on the next install!
rm -f /etc/mysql/debian.cnf rm -f /etc/mysql/debian.cnf
...@@ -93,6 +105,7 @@ fi ...@@ -93,6 +105,7 @@ fi
#DEBHELPER# #DEBHELPER#
# Modified dh_systemd_start snippet that's not added automatically # Modified dh_systemd_start snippet that's not added automatically
if [ -d /run/systemd/system ]; then if [ -d /run/systemd/system ]
then
systemctl --system daemon-reload >/dev/null || true systemctl --system daemon-reload >/dev/null || true
fi fi
...@@ -14,11 +14,16 @@ ...@@ -14,11 +14,16 @@
MAJOR_VER="${DPKG_MAINTSCRIPT_PACKAGE#mariadb-server-}" MAJOR_VER="${DPKG_MAINTSCRIPT_PACKAGE#mariadb-server-}"
# Just kill the invalid insserv.conf.d directory without fallback # Just kill the invalid insserv.conf.d directory without fallback
if [ -d "/etc/insserv.conf.d/mariadb/" ]; then if [ -d "/etc/insserv.conf.d/mariadb/" ]
then
rm -rf "/etc/insserv.conf.d/mariadb/" rm -rf "/etc/insserv.conf.d/mariadb/"
fi fi
if [ -n "$DEBIAN_SCRIPT_DEBUG" ]; then set -v -x; DEBIAN_SCRIPT_TRACE=1; fi if [ -n "$DEBIAN_SCRIPT_DEBUG" ]
then
set -v -x
DEBIAN_SCRIPT_TRACE=1
fi
${DEBIAN_SCRIPT_TRACE:+ echo "#42#DEBUG# RUNNING $0 $*" 1>&2 } ${DEBIAN_SCRIPT_TRACE:+ echo "#42#DEBUG# RUNNING $0 $*" 1>&2 }
export PATH=$PATH:/sbin:/usr/sbin:/bin:/usr/bin export PATH=$PATH:/sbin:/usr/sbin:/bin:/usr/bin
...@@ -32,7 +37,10 @@ stop_server() { ...@@ -32,7 +37,10 @@ stop_server() {
# Return immediately if there are no mysqld processes running on a host # Return immediately if there are no mysqld processes running on a host
# (leave containerized processes with the same name in other namespaces) # (leave containerized processes with the same name in other namespaces)
# as there is no point in trying to shutdown in that case. # as there is no point in trying to shutdown in that case.
if ! pgrep -x --nslist pid --ns $$ "mysqld|mariadbd" > /dev/null; then return; fi if ! pgrep -x --nslist pid --ns $$ "mysqld|mariadbd" > /dev/null
then
return
fi
set +e set +e
invoke-rc.d mariadb stop invoke-rc.d mariadb stop
...@@ -41,7 +49,8 @@ stop_server() { ...@@ -41,7 +49,8 @@ stop_server() {
set -e set -e
# systemctl could emit exit code 100=no init script (fresh install) # systemctl could emit exit code 100=no init script (fresh install)
if [ "$errno" != 0 ] && [ "$errno" != 100 ]; then if [ "$errno" != 0 ] && [ "$errno" != 100 ]
then
echo "Attempt to stop MariaDB/MySQL server returned exitcode $errno" 1>&2 echo "Attempt to stop MariaDB/MySQL server returned exitcode $errno" 1>&2
echo "There is a MariaDB/MySQL server running, but we failed in our attempts to stop it." 1>&2 echo "There is a MariaDB/MySQL server running, but we failed in our attempts to stop it." 1>&2
echo "Stop it yourself and try again!" 1>&2 echo "Stop it yourself and try again!" 1>&2
...@@ -156,7 +165,8 @@ stop_server ...@@ -156,7 +165,8 @@ stop_server
# If we use NIS then errors should be tolerated. It's up to the # If we use NIS then errors should be tolerated. It's up to the
# user to ensure that the mysql user is correctly setup. # user to ensure that the mysql user is correctly setup.
# Beware that there are two ypwhich one of them needs the 2>/dev/null! # Beware that there are two ypwhich one of them needs the 2>/dev/null!
if test -n "$(which ypwhich 2>/dev/null)" && ypwhich >/dev/null 2>&1; then if test -n "$(which ypwhich 2>/dev/null)" && ypwhich >/dev/null 2>&1
then
set +e set +e
fi fi
...@@ -171,13 +181,15 @@ fi ...@@ -171,13 +181,15 @@ fi
# #
# creating mysql group if he isn't already there # creating mysql group if he isn't already there
if ! getent group mysql >/dev/null; then if ! getent group mysql >/dev/null
then
# Adding system group: mysql. # Adding system group: mysql.
addgroup --system mysql >/dev/null addgroup --system mysql >/dev/null
fi fi
# creating mysql user if he isn't already there # creating mysql user if he isn't already there
if ! getent passwd mysql >/dev/null; then if ! getent passwd mysql >/dev/null
then
# Adding system user: mysql. # Adding system user: mysql.
adduser \ adduser \
--system \ --system \
...@@ -195,7 +207,8 @@ set -e ...@@ -195,7 +207,8 @@ set -e
# if there's a symlink, let's store where it's pointing, because otherwise # if there's a symlink, let's store where it's pointing, because otherwise
# it's going to be lost in some situations # it's going to be lost in some situations
for dir in DATADIR LOGDIR; do for dir in DATADIR LOGDIR
do
checkdir=$(eval echo "$"$dir) checkdir=$(eval echo "$"$dir)
if [ -L "$checkdir" ]; then if [ -L "$checkdir" ]; then
# Use mkdir option 'Z' to create with correct SELinux context. # Use mkdir option 'Z' to create with correct SELinux context.
...@@ -205,7 +218,8 @@ for dir in DATADIR LOGDIR; do ...@@ -205,7 +218,8 @@ for dir in DATADIR LOGDIR; do
done done
# creating mysql home directory # creating mysql home directory
if [ ! -d $mysql_datadir ] && [ ! -L $mysql_datadir ]; then if [ ! -d $mysql_datadir ] && [ ! -L $mysql_datadir ]
then
# Use mkdir option 'Z' to create with correct SELinux context. # Use mkdir option 'Z' to create with correct SELinux context.
mkdir -Z $mysql_datadir mkdir -Z $mysql_datadir
fi fi
...@@ -213,7 +227,8 @@ fi ...@@ -213,7 +227,8 @@ fi
# As preset blocksize of GNU df is 1024 then available bytes is $df_available_blocks * 1024 # As preset blocksize of GNU df is 1024 then available bytes is $df_available_blocks * 1024
# 4096 blocks is then lower than 4 MB # 4096 blocks is then lower than 4 MB
df_available_blocks=`LC_ALL=C BLOCKSIZE= df --output=avail "$datadir" | tail -n 1` df_available_blocks=`LC_ALL=C BLOCKSIZE= df --output=avail "$datadir" | tail -n 1`
if [ "$df_available_blocks" -lt "4096" ]; then if [ "$df_available_blocks" -lt "4096" ]
then
echo "ERROR: There's not enough space in $mysql_datadir/" 1>&2 echo "ERROR: There's not enough space in $mysql_datadir/" 1>&2
db_stop db_stop
exit 1 exit 1
...@@ -232,7 +247,6 @@ find $mysql_datadir -follow -not -group mysql -print0 2>/dev/null \ ...@@ -232,7 +247,6 @@ find $mysql_datadir -follow -not -group mysql -print0 2>/dev/null \
| xargs -0 --no-run-if-empty chgrp mysql | xargs -0 --no-run-if-empty chgrp mysql
set -e set -e
db_stop db_stop
#DEBHELPER# #DEBHELPER#
...@@ -4,9 +4,11 @@ set -e ...@@ -4,9 +4,11 @@ set -e
#DEBHELPER# #DEBHELPER#
# Modified dh_systemd_start snippet that's not added automatically # Modified dh_systemd_start snippet that's not added automatically
if [ -d /run/systemd/system ]; then if [ -d /run/systemd/system ]
then
deb-systemd-invoke stop mariadb.service >/dev/null deb-systemd-invoke stop mariadb.service >/dev/null
# Modified dh_installinit snippet to only run with sysvinit # Modified dh_installinit snippet to only run with sysvinit
elif [ -x "/etc/init.d/mariadb" ]; then elif [ -x "/etc/init.d/mariadb" ]
then
invoke-rc.d mariadb stop || exit $? invoke-rc.d mariadb stop || exit $?
fi fi
Markdown is supported
0%
or
You are about to add 0 people to the discussion. Proceed with caution.
Finish editing this message first!
Please register or to comment